<?
#################################################################
#
# cautivo.php
#
# Pagina principal del portal cautivo de Iztaci - NAC
#
# 26-oct-2009a
#


require('/etc/snort/nac.conf');
require ('funciones.inc');

print "<html>
<HEAD>
<title>NAC - Portal cautivo</title>
<META HTTP-EQUIV=\"Pragma\" CONTENT=\"no-cache\">
<META HTTP-EQUIV=\"Expires\" CONTENT=\"-1\">
</HEAD>
<body bgcolor=#CCCCFF background=stop.jpg>
<center>";



/* Averiguamos si esta restringido */

conectadb();

$res = ViolacionesActivas( $_SERVER['REMOTE_ADDR'] );

/* Si hay violaciones para esta direccion con id_castigo < 100 */
/* entonces estamos restringidos                               */

/* Violaciones positivas son las de castigos < 100 */

/*
$violacionpositiva = FALSE;
while ( $rowviolacion = DameRenglon($res) ) {

  if ( DameRenglon(sql("SELECT id_castigo FROM politicas,violaciones
                        WHERE id_castigo < 100
                        AND violaciones.signature    =     politicas.signature
                        AND violaciones.id_violacion = " . $rowviolacion['id_violacion'] )) ) {

        $violacionpositiva = TRUE;

  }

}
*/

if ( DameRenglon($res) ) {

   /* Con el DameRenglon() anterior lo movimos, */
   /* asi que lo devolvemos al principio        */
   
   pg_result_seek ($res, 0);

   if ( $_POST['activar'] ) {

      $oportunidades = Oportunidades($_SERVER['REMOTE_ADDR']);

      if ( $oportunidades > 0 ) {

         /* Ponemos una "violacion negativa" en los eventos */

         /* El sig_sid de la violacion negativa es "3000001" */
         /* El sid para el "sensor" de este script es "1000" */

         $cidrow = DameRenglon(sql ("SELECT max(cid) AS maxcid FROM event"));
         $newcid = $cidrow['maxcid'];
         $newcid++;

         sql("INSERT INTO event 
                VALUES ( 1000,
                        $newcid,
                        (SELECT sig_id FROM signature WHERE sig_sid=3000001),
                        now() AT TIME ZONE 'UTC'
                       );
              INSERT INTO iphdr
                VALUES ( 1000,
                         $newcid,
                         " . ip2int($_SERVER['REMOTE_ADDR']) . ",
                         0,
                         4,
                         DEFAULT,DEFAULT,DEFAULT,DEFAULT,DEFAULT,DEFAULT,DEFAULT,0,DEFAULT)");

         /* Reducimos su cuenta de oportunidades */
         $oportunidades--;
         sql("UPDATE usuarios SET oportunidades = $oportunidades
                              WHERE id_usuario = '" . $_SERVER['REMOTE_ADDR'] . "'");

         /* Marcamos las violaciones que tiene ahorita como inactivas */
         while ( $row = DameRenglon($res) ) {
echo "<b>Inactivando violacion - " . $row['id_violacion'] . "</b>";
            sql("UPDATE violaciones
                 SET activa = 'f'
                 WHERE id_violacion = " . $row['id_violacion']);
         }

         /* Y avisamos de la buena noticia */
         print "<h1>Su acceso a Internet ha sido restaurado</h1>\n";
         print "<hr>";
         print "<p>Le recordamos que todas las violaciones y las reactivaciones son registradas para futura referencia.";
      }
      else {
         print "<p><b>Ud. ha agotado sus oportunidades para reactivar su acceso a Internet. Solicite la reactivaci&oacute;n al departamento de sistemas.</b>";
      }
   }
   else {

   print "<h1>Su acceso a Internet ha sido restringido</h1>\n";
   print "<hr>
          <p>
          El sistema de control de acceso ha determinado que su estaci&oacute;n de trabajo ha generado las siguientes violaciones de las pol&iacute;ticas de uso aceptable de la red:\n";

   print "<br><br><br>\n";
   print "<table border=1 width=80% cellspacing=0>\n";
   print "<th>Firma\n";
   print "<th>Descripci&oacute;n\n";
   print "<th>Fuente\n";
   print "<th>Destino\n";
   print "<th>Hora\n";

   while ( $row = DameRenglon($res) ) {
      print "\n
               <tr>
               <td align=center>" . $row['signature'] . "
               <td>" . $row['sig_name']  . "
               <td align=center>" . int2ip($row['ip_src']) . "
               <td align=center>" . int2ip($row['ip_dst']) . "
               <td align=center>" . $row['timestamp'];
   }

   print "\n</table>";


   $oportunidades = Oportunidades($_SERVER['REMOTE_ADDR']);



   print "<br><br>\n";

   /* Aviso de oportunidades */
   if ( $oportunidades > 0 ) {

      print "<p>Ud. puede reactivar su acceso durante una cantidad limitada de ocasiones. Una vez agotadas las oportunidades, tendr que solicitar la reactivaci&oacute;n al departamento de sistemas.";

      print "<p>Le recordamos que todas las violaciones y las reactivaciones son registradas para futura referencia.";
      if ( $oportunidades > 1 ) {
         print "<p>Le quedan <b>$oportunidades</b> oportunidades.";
      }
      else {
         print "<p>Le queda <b>una</b> oportunidad.";
      }

      print "<br><br>\n";
      print "<form action=cautivo.php method=POST>
             <input type=submit name=activar value=Reactivar>
             </form>";
   } else {
      print "<p><b>Ud. ha agotado sus oportunidades para reactivar su acceso a Internet. Solicite la reactivacin al departamento de sistemas.</b>";
   }



}

}

else {

   print "<center><h1>Tu acceso a Internet no est restringido</h1></center>\n";
   print "<hr>\n";
   print "<p>Si acabas de solicitar la re-activacin de tu acceso, en unos minutos ser restablecido.";

}


print "</body><HEAD>
<META HTTP-EQUIV=\"Pragma\" CONTENT=\"no-cache\">
<META HTTP-EQUIV=\"Expires\" CONTENT=\"-1\">
</HEAD>
</html>";

?>
